#include <sourcemod>
#include <sdktools>

#define is_user_steam(%1) ((StrContains(%1,"STEAM_0:0:") != -1 || StrContains(%1, "STEAM_0:1:") != -1 ))

#define charsmax(%1) ((sizeof(%1) - 1))

#define g_Max 32

new const String:g_Langcmd[][] = { "say !dolacz","say !join","say_team !dolacz","say_team !join" }

new String:g_Prefix[64]
new String:g_Group[64]

new bool:g_Steam[g_Max + 1]
new bool:g_Have[g_Max + 1]
new bool:g_Insert[g_Max + 1]

new String:g_SteamID[g_Max + 1][32]
new g_Accept[g_Max + 1]
new g_Flag[g_Max + 1]

new Handle:Time
new Handle:Prefix
new Handle:Group

new Handle:g_SqlTuple

public Plugin:myinfo = 
{
	name = "Auto Steam Invite",
	author = "speedkill & benio101",
	description = "",
	version = "1.0",
	url = "http://amxx.pl/"
}

public OnPluginStart()
{
	HookEvent("player_spawn", SpawnEvent)
	
	register_cvars()
	
	for(new i;i<sizeof g_Langcmd;i++)
		RegConsoleCmd(g_Langcmd[i], ask)
	
	LoadTranslations("common.phrases")
	LoadTranslations("SteamInvite")
	AutoExecConfig(true, "SteamInvite")
}
public register_cvars()
{
	Prefix = CreateConVar("steam_autoinvite_prefix", "[Steam Invite]", "Informations prefix")
	Group = CreateConVar("steam_autoinvite_group", "Testowa Grupa", "Name of Group, wchich invite will be send")
	Time = CreateConVar("steam_autoinvite_advertisement_time", "90.0", "Time between advertisements. Set 0.0 to disable",_,true,0.0)
	
}
public OnConfigsExecuted()
{
	sql_connect()
	
	GetConVarString(Prefix, g_Prefix, charsmax(g_Prefix))
	GetConVarString(Group, g_Group, charsmax(g_Group))
	
	new Float:g_Time = GetConVarFloat(Time)
	
	if(g_Time >= 1.0)
		CreateTimer(g_Time, advertisement,_,TIMER_REPEAT)
	
}
public sql_connect()
{
	new String:error[255];
	
	if (SQL_CheckConfig("SteamInvite"))
	{
		g_SqlTuple = SQL_Connect("SteamInvite",true,error,charsmax(error))
		
		if(g_SqlTuple == INVALID_HANDLE)
			SetFailState("Can't connect with database.")
		
		SQL_FastQuery(g_SqlTuple, "CREATE TABLE IF NOT EXISTS `Steam` (steam_id VARCHAR(32) NOT NULL, unix_time INT(11) NOT NULL DEFAULT 0, flag INT(1) NOT NULL DEFAULT 1, accept INT(1) NOT NULL DEFAULT 0, PRIMARY KEY(steam_id))")
		
	}
}
public Action:advertisement(Handle:timer)
{
	for(new id = 1; id <= g_Max; id++)
	{
		if(g_Steam[id] && g_Accept[id] == 1)
		{
			PrintToChat(id,"\x04%s \x03%t",g_Prefix,"g_Ad")
		}
	}
}
public Action:SpawnEvent(Handle:event,const String:name[],bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event,"userid"))
	
	if(g_Steam[client] && IsPlayerAlive(client))
	{
		if(!g_Have[client])
		{
			g_Have[client] = true
			menu(client)
		}
	}
}
public OnClientAuthorized(client)
{
	GetClientAuthString(client, g_SteamID[client],charsmax(g_SteamID[]))
	
	if(is_user_steam(g_SteamID[client]))
	{
		g_Steam[client] = true
		sql_load(client)
	}
	
}
public OnClientDisconnect(client)
{
	if(g_Steam[client])
	{
		g_Have[client] = false
		g_Steam[client] = false
		g_Insert[client] = false
		g_Accept[client] = 0
		g_Flag[client] = 0
	}
}
public Action:ask(client,args)
{
	if(g_Steam[client])
	{
		if(g_Flag[client] == 0)
		{
			menu(client)
		}
		else
		{
			PrintToChat(client,"\x04%s \x03%t",g_Prefix,"g_Wait")
		}
	}
	else
	{
		PrintToChat(client,"\x04%s \x03%t",g_Prefix,"g_Ns")
	}
}
public menu(client)
{
	new Handle:panel = CreatePanel()
	
	new String:title[128]
	
	FormatEx(title,charsmax(title),"%t %s ?","g_Ask",g_Group)
	SetPanelTitle(panel, title)
	
	FormatEx(title,charsmax(title),"%t","g_Yes")
	DrawPanelItem(panel, title)
	FormatEx(title,charsmax(title),"%t","g_No")
	DrawPanelItem(panel, title)
	
	SendPanelToClient(panel, client, choosing, 20)
	
	CloseHandle(panel)
}
public choosing(Handle:menu, MenuAction:action, client, item)
{	
	if(action == MenuAction_Select)
	{
		switch(item)
		{
			case 1:
			{
				g_Accept[client] = 1
				g_Flag[client] = 1
				PrintToChat(client,"\x04%s \x03%t",g_Prefix,"g_Smi")
				sql_save(client)
			}
			case 2:
			{
				g_Accept[client] = 0
				g_Flag[client] = 0
				PrintToChat(client,"\x04%s \x03%t",g_Prefix,"g_Dw")
			}
		}
	}
	else if(action == MenuAction_End)
	{
		CloseHandle(menu)
	}
}
public sql_load(client)
{
	new String:szTemp[512]
	
	new client_id = GetClientUserId(client)
	
	FormatEx(szTemp,charsmax(szTemp),"SELECT * FROM `Steam` WHERE `steam_id` = '%s'",g_SteamID[client])
	SQL_TQuery(g_SqlTuple, check, szTemp, client_id)
}
public check(Handle:owner, Handle:query, const String:error[], any:data)
{
	new client = GetClientOfUserId(data)
	
	if(query == INVALID_HANDLE)
	{
		LogError("<Query> Error: %s", error)
		return
	}
	
	if(SQL_GetRowCount(query)) 
	{
		while(SQL_FetchRow(query))
		{
			g_Insert[client] = true
			g_Accept[client] = SQL_FetchInt(query, 2)
			g_Flag[client] = SQL_FetchInt(query, 3)
			
			if(g_Accept[client] == 1)
				g_Have[client] = true
		}
	}
	else
	{
		g_Insert[client] = false
		g_Have[client] = false
	}
}
public sql_save(client)
{
	new String:szTemp[512]
	
	if(g_Insert[client])
	{
		FormatEx(szTemp,charsmax(szTemp),"UPDATE `Steam` SET `unix_time` = UNIX_TIMESTAMP(),`accept` = '%d' WHERE `steam_id` = '%s'",g_Accept[client],g_SteamID[client])
		SQL_TQuery(g_SqlTuple, IgnoreHandle, szTemp)
	}
	else
	{
		FormatEx(szTemp,charsmax(szTemp),"INSERT INTO `Steam` (`steam_id`,`unix_time`,`accept`) VALUES ('%s',UNIX_TIMESTAMP(),'%d')",g_SteamID[client],g_Accept[client])
		SQL_TQuery(g_SqlTuple, IgnoreHandle, szTemp)
	}
}

public IgnoreHandle(Handle:owner, Handle:query, const String:error[], any:data)
{
	if(!StrEqual("", error))
		LogError("SQL Error: %s", error)
	
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
