/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <sqlx>
#include <colorchat>
#include <hamsandwich>

#define PLUGIN "Auto Steam Invite"
#define VERSION "1.0"
#define AUTHOR "speedkill & benio101"

#define is_user_steam(%1) ((contain(%1,"STEAM_0:0:") != -1 || contain(%1, "STEAM_0:1:") != -1))

#define g_Max 32

new const g_Langcmd[][] = { "say /dolacz","say /join","say_team /dolacz","say_team /join" }

new g_Prefix[64]
new g_Group[64]

new bool:g_Steam[g_Max + 1]
new bool:g_Have[g_Max + 1]
new bool:g_Insert[g_Max + 1]

new g_SteamID[g_Max + 1][32]
new g_Accept[g_Max + 1]
new g_Flag[g_Max + 1]

new Handle:g_SqlTuple

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	RegisterHam(Ham_Spawn, "player", "player_spawn", 1)
	
	register_cvars()
	
	for(new i;i<sizeof g_Langcmd;i++)
		register_clcmd(g_Langcmd[i], "ask")
	
	
}
public register_cvars()
{
	register_dictionary("steam_autoinvite.txt")
	
	register_cvar("steam_autoinvite_prefix","[Steam Invite]")
	register_cvar("steam_autoinvite_group","Testowa Grupa")
	
	register_cvar("steam_autoinvite_advertisement_time","90.0")
	
	register_cvar("steam_autoinvite_host", "localhost", FCVAR_PROTECTED)
	register_cvar("steam_autoinvite_user", "root", FCVAR_PROTECTED)
	register_cvar("steam_autoinvite_pass", "root", FCVAR_PROTECTED)
	register_cvar("steam_autoinvite_db", "db", FCVAR_PROTECTED)
}
public plugin_cfg()
{	
	sql_connect()
	
	get_cvar_string("steam_autoinvite_prefix",g_Prefix,charsmax(g_Prefix))
	get_cvar_string("steam_autoinvite_group",g_Group,charsmax(g_Group))
	
	if(get_cvar_float("steam_autoinvite_advertisement_time") >= 1.0)
		set_task(get_cvar_float("steam_autoinvite_advertisement_time"),"advertisement",.flags="b")
	
}
public sql_connect()
{
	new Host[32], User[32], Pass[32], DB[32]
	
	get_cvar_string("steam_autoinvite_host", Host, charsmax(Host))
	get_cvar_string("steam_autoinvite_user", User, charsmax(User))
	get_cvar_string("steam_autoinvite_pass", Pass, charsmax(Pass))
	get_cvar_string("steam_autoinvite_db", DB, charsmax(DB))
	
	g_SqlTuple = SQL_MakeDbTuple(Host,User,Pass,DB)
	
	new error, szError[128]
	new Handle:hConn = SQL_Connect(g_SqlTuple,error,szError,charsmax(szError))
	
	if(error)
		set_fail_state("Plugin can't connect with database.")
	
	
	new Handle:Queries = SQL_PrepareQuery(hConn,"CREATE TABLE IF NOT EXISTS `Steam`(steam_id VARCHAR(32) NOT NULL, unix_time INT(11) NOT NULL DEFAULT 0, flag INT(1) NOT NULL DEFAULT 1, accept INT(1) NOT NULL DEFAULT 0, PRIMARY KEY(steam_id))")
	
	SQL_Execute(Queries)
	SQL_FreeHandle(Queries)
	SQL_FreeHandle(hConn)
}
public plugin_end()
{
	SQL_FreeHandle(g_SqlTuple)
}
public player_spawn(id)
{
	if(g_Steam[id] && is_user_alive(id))
	{
		if(!g_Have[id])
		{
			g_Have[id] = true
			menu(id)
		}
	}
}			
public client_authorized(id)
{
	get_user_authid(id, g_SteamID[id], charsmax(g_SteamID[]))
	if(is_user_steam(g_SteamID[id]))
	{
		g_Steam[id] = true
		sql_load(id)
	}
}
public client_disconnect(id)
{
	if(g_Steam[id])
	{
		g_Have[id] = false
		g_Steam[id] = false
		g_Insert[id] = false
		g_Accept[id] = 0
		g_Flag[id] = 0
	}
}
public ask(id)
{
	if(g_Steam[id])
	{
		if(!g_Flag[id])
			menu(id)
		else
			ColorChat(id,GREEN,"%s ^x03%L",g_Prefix,LANG_PLAYER,"g_Wait")
	}
	else
	{
		ColorChat(id,GREEN,"%s ^x03%L",g_Prefix,LANG_PLAYER,"g_Ns")
	}
}
public menu(id)
{
	new title[128]
	
	formatex(title,charsmax(title),"\d%L \r%s ?",LANG_PLAYER,"g_Ask",g_Group)
	new menu = menu_create(title, "choosing")
	
	formatex(title,charsmax(title),"\r%L",LANG_PLAYER,"g_Yes")
	menu_additem(menu,title)
	formatex(title,charsmax(title),"\y%L",LANG_PLAYER,"g_No")
	menu_additem(menu,title)
	
	formatex(title,charsmax(title),"%L",LANG_PLAYER,"g_Exit")
	menu_setprop(menu, MPROP_EXITNAME,title)
	
	menu_display(id, menu)
}
public choosing(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED	
	}
	switch(item)
	{
		case 0:
		{
			g_Accept[id] = 1
			g_Flag[id] = 1
			ColorChat(id,GREEN,"%s ^x03%L",g_Prefix,LANG_PLAYER,"g_Smi")
			sql_save(id)
		}
		case 1:
		{
			g_Accept[id] = 0
			g_Flag[id] = 0
			ColorChat(id,GREEN,"%s ^x03%L",g_Prefix,LANG_PLAYER,"g_Dw")
		}
	}
	menu_destroy(menu)
	return PLUGIN_HANDLED
}
public advertisement()
{
	for(new id=1;id<=g_Max;id++)
	{
		if(g_Steam[id] && g_Accept[id])
		{
			ColorChat(id,GREEN,"%s ^x03%L",g_Prefix,LANG_PLAYER,"g_Ad")
		}
	}
}
public sql_save(id)
{
	new szTemp[512]
	
	if(g_Insert[id])
	{
		formatex(szTemp,charsmax(szTemp),"UPDATE `Steam` SET `unix_time` = UNIX_TIMESTAMP(),`accept` = '%d' WHERE `steam_id` = '%s'",g_Accept[id],g_SteamID[id])
		SQL_ThreadQuery(g_SqlTuple,"IgnoreHandle",szTemp)
	}
	else
	{
		formatex(szTemp,charsmax(szTemp),"INSERT INTO `Steam` (`steam_id`,`unix_time`,`accept`) VALUES ('%s',UNIX_TIMESTAMP(),'%d')",g_SteamID[id],g_Accept[id])
		SQL_ThreadQuery(g_SqlTuple, "IgnoreHandle", szTemp)
	}
}
public sql_load(id)
{
	new szTemp[512],data[1]
	data[0] = id
	formatex(szTemp,charsmax(szTemp),"SELECT * FROM `Steam` WHERE `steam_id` = '%s'",g_SteamID[id])
	SQL_ThreadQuery(g_SqlTuple,"check",szTemp, data, sizeof(data))
}

public check(failstate, Handle:query, error[],errcode, data[], datasize)
{
	if(failstate != TQUERY_SUCCESS)
	{
		log_amx("<Query> Error: %s", error)
		return
	}
	new id = data[0]
	
	if(SQL_NumRows(query))
	{
		g_Insert[id] = true
		g_Accept[id] = SQL_ReadResult(query, SQL_FieldNameToNum(query,"accept"))
		g_Flag[id] = SQL_ReadResult(query, SQL_FieldNameToNum(query,"flag"))
		if(g_Accept[id])
			g_Have[id] = true
	} 
	else
	{
		g_Insert[id] = false
		g_Have[id] = false
	}
}
public IgnoreHandle(failstate, Handle:query, error[], errnum)
{
	if(failstate != TQUERY_SUCCESS)
	{
		log_amx("<Query> Error: %s", error)
		return
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
